# coding:utf-8
'''
Created on 26 февр. 2016 г.

@author: popov_v
'''
import os
import datetime
import xml.etree.ElementTree as ET
import json

from webservices.functions import getTableCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from nci.functions.persons import normalizeSnils


def uploadResults(self, xmlIn):
    u'''Загрузка результатов прохождения слушателями циклов по ДПП ПК НПР. '''
    
    if not os.path.isdir(r'C:\accred_service_logs'):
        os.makedirs(r'C:\accred_service_logs')
    dateTime = str(datetime.datetime.now().strftime("%Y-%m-%d %H.%M.%S"))
    mypath = r'C:\accred_service_logs/'+"updateCCSR_"+dateTime
    if not os.path.isdir(mypath):
        os.makedirs(mypath)
    logFile = open(mypath+"/input.xml", "w")
    logFile.write(xmlIn)
    logFile.close()
    # работа с XML
    #ns = {'show': 'http://showcase.curs.ru',
    #      'soapenv': 'http://schemas.xmlsoap.org/soap/envelope'}
    root = ET.fromstring(xmlIn)
    command_json = root.attrib # атрибуты команды
    # получаем курсоры
    course_cycle_student = getTableCursor(command_json['pin'], 'medstaff', 'course_cycle_student')
    student_course_result = getTableCursor(command_json['pin'], 'medstaff', 'student_course_result')
    person = getTableCursor(command_json['pin'], 'nci', 'person')
    data = {"result":[]}
    # проходим по записям
    for rec in root.find('records').findall('rec'):
        error_text = ''
        course_cycle_student_id = rec.find('course_cycle_student_id').text
        snils = rec.find('snils').text
        accred_cycle_id = rec.find('accred_cycle_id').text
        course_cycle_id = rec.find('course_cycle_id').text
        if course_cycle_student.tryGet(course_cycle_student_id):
            if rec.find('passed').text:
                course_cycle_student.passed = True if rec.find('passed').text in ('True', 'true', '1') else False
                course_cycle_student.update()
            # обрабатываем остальные результаты
            student_course_result.clear()
            student_course_result.course_cycle_student_id = course_cycle_student.uid
            if rec.find('grade_get').text:
                student_course_result.grade_get = rec.find('grade_get').text
            if rec.find('grade_max').text:
                student_course_result.grade_max = rec.find('grade_max').text
            if rec.find('attendance').text:
                try:
                    attendance = float(rec.find('attendance').text)
                    student_course_result.attendance = attendance
                except:
                    error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля attendance - должно быть число.')
            if rec.find('eok_grade_test').text:
                try:
                    eok_grade_test = float(rec.find('eok_grade_test').text)
                    student_course_result.eok_grade_test = eok_grade_test
                except:
                    error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля eok_grade_test - должно быть число.')
            if rec.find('eok_grade_clinical').text:
                try:
                    eok_grade_clinical = float(rec.find('eok_grade_clinical').text)
                    student_course_result.eok_grade_clinical = eok_grade_clinical
                except:
                    error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля eok_grade_clinical - должно быть число.')
            if rec.find('interview_grade').text:
                try:
                    interview_grade = float(rec.find('interview_grade').text)
                    student_course_result.interview_grade = interview_grade
                except:
                    error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля interview_grade - должно быть число.')
            if rec.find('practical_grade').text:
                try:
                    practical_grade = float(rec.find('practical_grade').text)
                    student_course_result.practical_grade = practical_grade
                except:
                    error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля practical_grade - должно быть число.')
            if not student_course_result.tryUpdate():
                student_course_result.insert()
        else:
            try:
                snils = normalizeSnils(snils)
            except:
                error_text = u'%s, %s' % (error_text, u'СНИЛС должен состоять из 9 значащих и 2 контрольных цифр.')
            person.setRange('snils', snils)
            if person.tryFirst():
                course_cycle_student.setRange('person_id', person.uid)
                course_cycle_student.setRange('accred_cycle_id', accred_cycle_id)
                course_cycle_student.setRange('course_cycle_id', course_cycle_id)
                if course_cycle_student.tryFirst():
                    if rec.find('passed').text:
                        course_cycle_student.passed = True if rec.find('passed').text in ('True', 'true', '1') else False
                        course_cycle_student.update()
                    # обрабатываем остальные результаты
                    student_course_result.clear()
                    student_course_result.course_cycle_student_id = course_cycle_student.uid
                    if rec.find('grade_get').text:
                        student_course_result.grade_get = rec.find('grade_get').text
                    if rec.find('grade_max').text:
                        student_course_result.grade_max = rec.find('grade_max').text
                    if rec.find('attendance').text:
                        try:
                            attendance = float(rec.find('attendance').text)
                            student_course_result.attendance = attendance
                        except:
                            error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля attendance - должно быть число.')
                    if rec.find('eok_grade_test').text:
                        try:
                            eok_grade_test = float(rec.find('eok_grade_test').text)
                            student_course_result.eok_grade_test = eok_grade_test
                        except:
                            error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля eok_grade_test - должно быть число.')
                    if rec.find('eok_grade_clinical').text:
                        try:
                            eok_grade_clinical = float(rec.find('eok_grade_clinical').text)
                            student_course_result.eok_grade_clinical = eok_grade_clinical
                        except:
                            error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля eok_grade_clinical - должно быть число.')
                    if rec.find('interview_grade').text:
                        try:
                            interview_grade = float(rec.find('interview_grade').text)
                            student_course_result.interview_grade = interview_grade
                        except:
                            error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля interview_grade - должно быть число.')
                    if rec.find('practical_grade').text:
                        try:
                            practical_grade = float(rec.find('practical_grade').text)
                            student_course_result.practical_grade = practical_grade
                        except:
                            error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля practical_grade - должно быть число.')
                    if not student_course_result.tryUpdate():
                        student_course_result.insert()
                else:
                    error_text = u'Не найден слушатель цикла по ДПП ПК НПР.'
            else:
                error_text = u'Не найдено ФЛ по данному СНИЛС.'

        data['result'].append({'rec': {'course_cycle_student_id': course_cycle_student_id,
                                       'accred_cycle_id': accred_cycle_id,
                                       'course_cycle_id': course_cycle_id,
                                       'snils': snils,
                                       'status': 'Ok' if not error_text else error_text
                                           }
                                   })

    # вывод результата  
    xmlOut = XMLJSONConverter.jsonToXml(json.dumps(data))
    logFile = open(mypath+"/output.xml", "w")
    logFile.write(xmlOut)
    logFile.close()
    return xmlOut