# coding:utf-8
'''
Created on 26 февр. 2016 г.

@author: popov_v
'''
import os
import datetime
import xml.etree.ElementTree as ET
import json

from webservices.functions import getTableCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from nci.functions.persons import normalizeSnils


def uploadResults(self, xmlIn):
    u'''Загрузка результатов прохождения слушателями мероприятий в рамках цикла аккредитации. '''
    
    if not os.path.isdir(r'C:\accred_service_logs'):
        os.makedirs(r'C:\accred_service_logs')
    dateTime = str(datetime.datetime.now().strftime("%Y-%m-%d %H.%M.%S"))
    mypath = r'C:\accred_service_logs/'+"updateCCSR_"+dateTime
    if not os.path.isdir(mypath):
        os.makedirs(mypath)
    logFile = open(mypath+"/input.xml", "w")
    logFile.write(xmlIn)
    logFile.close()
    # работа с XML
    #ns = {'show': 'http://showcase.curs.ru',
    #      'soapenv': 'http://schemas.xmlsoap.org/soap/envelope'}
    root = ET.fromstring(xmlIn)
    command_json = root.attrib # атрибуты команды
    # получаем курсоры
    edu_event_student = getTableCursor(command_json['pin'], 'medstaff', 'edu_event_student')
    student_edu_event_result = getTableCursor(command_json['pin'], 'medstaff', 'student_edu_event_result')
    person = getTableCursor(command_json['pin'], 'nci', 'person')
    data = {"result":[]}
    # проходим по записям
    for rec in root.find('records').findall('rec'):
        error_text = ''
        edu_event_student_id = rec.find('edu_event_student_id').text
        snils = rec.find('snils').text
        accred_cycle_id = rec.find('accred_cycle_id').text
        edu_event_id = rec.find('edu_event_id').text
        if edu_event_student.tryGet(edu_event_student_id):
            if rec.find('passed').text:
                edu_event_student.passed = True if rec.find('passed').text in ('True', 'true', '1') else False
                edu_event_student.update()
            # обрабатываем остальные результаты
            student_edu_event_result.clear()
            student_edu_event_result.edu_event_student_id = edu_event_student.uid
            if rec.find('grade_get').text:
                student_edu_event_result.grade_get = rec.find('grade_get').text
            if rec.find('grade_max').text:
                student_edu_event_result.grade_max = rec.find('grade_max').text
            if rec.find('eok_grade_test').text:
                try:
                    eok_grade_test = float(rec.find('eok_grade_test').text)
                    student_edu_event_result.eok_grade_test = eok_grade_test
                except:
                    error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля eok_grade_test - должно быть число.')
            if rec.find('eok_grade_clinical').text:
                try:
                    eok_grade_clinical = float(rec.find('eok_grade_clinical').text)
                    student_edu_event_result.eok_grade_clinical = eok_grade_clinical
                except:
                    error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля eok_grade_clinical - должно быть число.')
            if not student_edu_event_result.tryUpdate():
                student_edu_event_result.insert()
        else:
            try:
                snils = normalizeSnils(snils)
            except:
                error_text = u'%s, %s' % (error_text, u'СНИЛС должен состоять из 9 значащих и 2 контрольных цифр.')
            person.setRange('snils', snils)
            if person.tryFirst():
                edu_event_student.setRange('person_id', person.uid)
                edu_event_student.setRange('accred_cycle_id', accred_cycle_id)
                edu_event_student.setRange('edu_event_id', edu_event_id)
                if edu_event_student.tryFirst():
                    if rec.find('passed').text:
                        edu_event_student.passed = True if rec.find('passed').text in ('True', 'true', '1') else False
                        edu_event_student.update()
                    # обрабатываем остальные результаты
                    student_edu_event_result.clear()
                    student_edu_event_result.edu_event_student_id = edu_event_student.uid
                    if rec.find('grade_get').text:
                        student_edu_event_result.grade_get = rec.find('grade_get').text
                    if rec.find('grade_max').text:
                        student_edu_event_result.grade_max = rec.find('grade_max').text
                    if rec.find('eok_grade_test').text:
                        try:
                            eok_grade_test = float(rec.find('eok_grade_test').text)
                            student_edu_event_result.eok_grade_test = eok_grade_test
                        except:
                            error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля eok_grade_test - должно быть число.')
                    if rec.find('eok_grade_clinical').text:
                        try:
                            eok_grade_clinical = float(rec.find('eok_grade_clinical').text)
                            student_edu_event_result.eok_grade_clinical = eok_grade_clinical
                        except:
                            error_text = u'%s, %s' % (error_text, u'Невозможно декодировать значение поля eok_grade_clinical - должно быть число.')
                    if not student_edu_event_result.tryUpdate():
                        student_edu_event_result.insert()
                else:
                    error_text = u'Не найден слушатель цикла по ДПП ПК НПР.'
            else:
                error_text = u'Не найдено ФЛ по данному СНИЛС.'

        data['result'].append({'rec': {'edu_event_student_id': edu_event_student_id,
                                       'accred_cycle_id': accred_cycle_id,
                                       'edu_event_id': edu_event_id,
                                       'snils': snils,
                                       'status': 'Ok' if not error_text else error_text
                                           }
                                   })

    # вывод результата  
    xmlOut = XMLJSONConverter.jsonToXml(json.dumps(data))
    logFile = open(mypath+"/output.xml", "w")
    logFile.write(xmlOut)
    logFile.close()
    return xmlOut